//#define DEBUG

//#define DEBUG2

#define maxspeed 15

#include "defines.h"

#include <ctype.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include <util/delay.h>

#include "uart.h"
#include "i2c.h"

static uint16_t tmr;

static int32_t cnt_left,cnt_right;

static int types[24];
static int value[24];
static int pin[24];
static int prt[24];

static int8_t speed1s[20];
static int8_t speed1f[20];
static int8_t speed2s[20];
static int8_t speed2f[20];
static uint16_t time[20];
static int queue_size;
static uint8_t current_timer;

static int32_t startLeft, startRight;

static int adc_id;
static int adc_conv;

#define MAXSERVO 0xCB
#define MINSERVO 0x24

SIGNAL(SIG_INTERRUPT6){
  //printf("L");
  //cli();
  if(value[0x10]==2){
    cnt_left--;
  }else{
    cnt_left++;
  };
  //sei();
  return;
};

SIGNAL(SIG_INTERRUPT7){
  //cli();
  //printf("R");
  if(value[0x12]==2){
    cnt_right--;
  }else{
    cnt_right++;
  };
  //sei();
  return;
};

SIGNAL(SIG_OVERFLOW2){
  TCNT2=0x69; //0x69=255-150 - to get this interrupt each 150/16'000'000 sec

  //***************************************************************************************************
  //In this interrupt we 50 times per second (2150 cycles, each 150/16'000'000 sec):
  // 1) send servo-controlling signals (cycles 0..1679)
  // 2) do motor control iteration (cycle 1680)
  // 3) do ADC reading (cycles 1681-2149)
  //***************************************************************************************************

  //***************************************************************************************************
  //Here is servo-controlling block
  //***************************************************************************************************
  if(tmr<1680){

		  if(tmr<840){

		      if(tmr<420){

			      if(tmr<210){
		    
					uint8_t tmp=tmr;

				    if(types[0]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x01); }; //Set PA0 pin to 1
				      uint16_t xxx=value[0];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xFE); }; //Set PA0 pin to 0
				    };
				    if(types[1]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x02); }; //Set PA1 pin to 1
				      uint8_t xxx=value[1];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xFD); }; //Set PA1 pin to 0
				    };

				  }else{

				    uint8_t tmp=tmr-210;
		  

					if(types[2]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x04); }; //Set PA2 pin to 1
				      uint8_t xxx=value[2];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xFB); }; //Set PA2 pin to 0
				    };
					if(types[3]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x08); }; //Set PA3 pin to 1
				      uint8_t xxx=value[3];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xF7); }; //Set PA3 pin to 0
				    };

				  };
		      }else{

				  if(tmr<630){

				    uint8_t tmp=tmr-420;

					if(types[4]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x10); }; //Set PA4 pin to 1
				      uint8_t xxx=value[4];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xEF); }; //Set PA4 pin to 0
				    };
					if(types[5]==2){
					  if(tmr==420){ outb(PORTF,inb(PORTF) | 0x20); }; //Set PA5 pin to 1
				      uint8_t xxx=value[5];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmr-420==xxx){ outb(PORTF,inb(PORTF) & 0xDF); }; //Set PA5 pin to 0
				    };

				  }else{
		  
					uint8_t tmp=tmr-630;

				    if(types[6]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x40); }; //Set PA6 pin to 1
				      uint8_t xxx=value[6];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0xBF); }; //Set PA6 pin to 0
				    };
					if(types[7]==2){
					  if(tmp==0){ outb(PORTF,inb(PORTF) | 0x80); }; //Set PA7 pin to 1
				      uint8_t xxx=value[7];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTF,inb(PORTF) & 0x7F); }; //Set PA7 pin to 0
				    };

				  };
		      };
		  }else{
		      if(tmr<1260){

				  if(tmr<1050){

				    uint8_t tmp=tmr-840;

					if(types[8]==2){
					  if(tmp==0){ outb(PORTG,inb(PORTG) | 0x01); }; //Set PG0 pin to 1
				      uint8_t xxx=value[8];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTA,inb(PORTA) & 0xFE); }; //Set PG0 pin to 0
				    };
				    if(types[9]==2){
					  if(tmp==0){ outb(PORTC,inb(PORTC) | 0x02); }; //Set PG1 pin to 1
				      uint8_t xxx=value[9];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTC,inb(PORTC) & 0xFD); }; //Set PG1 pin to 0
				    };

				  }else{

				    uint8_t tmp=tmr-1050;
		    
					if(types[10]==2){
					  if(tmp==0){ outb(PORTC,inb(PORTC) | 0x04); }; //Set PG2 pin to 1
				      uint8_t xxx=value[10];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTC,inb(PORTC) & 0xFB); }; //Set PG2 pin to 0
				    };
					if(types[11]==2){
					  if(tmp==0){ outb(PORTC,inb(PORTC) | 0x08); }; //Set PG3 pin to 1
				      uint8_t xxx=value[11];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTC,inb(PORTC) & 0xF7); }; //Set PG3 pin to 0
				    };

				  };
			  }else{
				  if(tmr<1470){

				    uint8_t tmp=tmr-1260;

				    if(types[12]==2){
					  if(tmp==0){ outb(PORTC,inb(PORTC) | 0x10); }; //Set PG4 pin to 1
				      uint8_t xxx=value[12];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTC,inb(PORTC) & 0xEF); }; //Set PG4 pin to 0
				    };
					if(types[13]==2){
					  if(tmp==0){ outb(PORTB,inb(PORTB) | 0x01); }; //Set PB0 pin to 1
				      uint8_t xxx=value[13];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTB,inb(PORTB) & 0xFE); }; //Set PB0 pin to 0
				    };

				  }else{

				    uint8_t tmp=tmr-1470;

				    if(types[14]==2){
					  if(tmp==0){ outb(PORTB,inb(PORTB) | 0x04); }; //Set PB2 pin to 1
				      uint8_t xxx=value[14];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
				      if(tmp==xxx){ outb(PORTB,inb(PORTB) & 0xFB); }; //Set PB2 pin to 0
				    };

					if(types[15]==2){
					  if(tmp==0){ outb(PORTB,inb(PORTB) | 0x80); }; //Set PB7 pin to 1
				      uint8_t xxx=value[15];
					  if(xxx>MAXSERVO){ xxx=MAXSERVO; };
					  if(xxx<MINSERVO){ xxx=MINSERVO; };
					  //xxx+=1260;
				      if(tmp==xxx){ outb(PORTB,inb(PORTB) & 0x7F); }; //Set PB7 pin to 0
				    };
			
				  };
			  };

		  };

  }else{

     //***************************************************************************************************
     //Here is motor-controlling block
     //***************************************************************************************************

     if(tmr==1680){
	    //printf("+");
		
		//Do motor control 50 times per second
		
		if( queue_size>0 ){

		  int32_t d,x,xx,y,t0,sp;

		  if( current_timer == time[0] ){

			t0=time[0];
			sp=speed2s[0];
		    d=speed2f[0]; d-=speed2s[0];
			x=current_timer; x*=d; x/=t0; x+=sp; x=200*x/250;
			y=current_timer; y=maxspeed*y*y*d/t0/0x7F/2+maxspeed*y*sp/0x7F+startRight;
			startRight=y;

			sp=speed1s[0];
		    d=speed1f[0]; d-=speed1s[0];
			x=current_timer; x*=d; x/=t0; x+=sp; x=200*x/250;
			y=current_timer; y=maxspeed*y*y*d/t0/0x7F/2+maxspeed*y*sp/0x7F+startLeft;
			startLeft=y;

			//printf("SpeedL=%d\n",10*cnt_left/time[0]);
			//printf("SpeedR=%d\n",10*cnt_right/time[0]);
		    queue_size--;
			int i;
			for(i=0; i<queue_size; i++){
			  speed1s[i]=speed1s[i+1];
			  speed1f[i]=speed1f[i+1];
			  speed2s[i]=speed2s[i+1];
			  speed2f[i]=speed2f[i+1];
			  time[i]=time[i+1];
			};
			current_timer=0;
		  };

		  if( queue_size>0 ){

			//Calculate current speed of right motor and set PWM and direction pins

			t0=time[0];
			sp=speed2s[0];

			//printf("t=%d\n",current_timer);

		    d=speed2f[0]; d-=speed2s[0];
			x=current_timer; x*=d; x/=t0; x+=sp; x=200*x/250; xx=x;
			y=current_timer; y=maxspeed*y*y*d/t0/0x7F/2+maxspeed*y*sp/0x7F+startRight;
			
			if(cnt_right>y+1){ x=x-10; };
			if(cnt_right>y+2){ x=x-20; };
			if(x-30>-127)if(cnt_right>y+3){ x=x-30; };
			if(x-40>-127)if(cnt_right>y+4){ x=x-40; };
			if(cnt_right<y-1){ x=x+10; };
			if(cnt_right<y-2){ x=x+20; };
			if(x+30<127)if(cnt_right<y-3){ x=x+30; };
			if(x+40<127)if(cnt_right<y-4){ x=x+40; };
			
			
			//printf("r=%ld x=%ld dx=%ld y=%ld\n",cnt_right,x,x-xx,y);
			if(x>0){
			    value[0x12]=1;
		    	outb(PORTD,inb(PORTD) & 0xDF); //Set PD5=0
				uint8_t speed=x;
				speed+=0x60;
				OCR3AH=0x00;
      			OCR3AL=speed;
			}else if(x<0){
			    value[0x12]=2;
	    		outb(PORTD,inb(PORTD) | 0x20); //Set PD5=1
				uint8_t speed=-x;
				speed+=0x60;
				OCR3AH=0x00;
      			OCR3AL=speed;
			}else{
				uint8_t speed=0;
				OCR3AH=0x00;
      			OCR3AL=speed;
			};

			//Calculate current speed of left motor and set PWM and direction pins

			sp=speed1s[0];

		    d=speed1f[0]; d-=speed1s[0];
			x=current_timer; x*=d; x/=t0; x+=sp; x=200*x/250; xx=x;
			y=current_timer; y=maxspeed*y*y*d/t0/0x7F/2+maxspeed*y*sp/0x7F+startLeft;
			
			
			if(cnt_left>y+1){ x=x-10; };
			if(cnt_left>y+2){ x=x-20; };
			if(x-30>-127)if(cnt_left>y+3){ x=x-30; };
			if(x-40>-127)if(cnt_left>y+4){ x=x-40; };
			if(cnt_left<y-1){ x=x+10; };
			if(cnt_left<y-2){ x=x+20; };
			if(x+30<127)if(cnt_left<y-3){ x=x+30; };
			if(x+40<127)if(cnt_left<y-4){ x=x+40; };
			
			
			//printf("l=%ld x=%ld dx=%ld y=%ld\n",cnt_left,x,x-xx,y);
			if(x>0){
			    value[0x10]=1;
				outb(PORTD,inb(PORTD) & 0xEF); //Set PD4=0 LeftDrive - Forward
				uint8_t speed=x;
				speed+=0x60;
				OCR3BH=0x00;
      			OCR3BL=speed;
			}else if(x<0){
			    value[0x10]=2;
				outb(PORTD,inb(PORTD) | 0x10); //Set PD4=1 LeftDrive - Backward
				uint8_t speed=-x;
				speed+=0x60;
				OCR3BH=0x00;
      			OCR3BL=speed;
			}else{
				uint8_t speed=0;
				OCR3BH=0x00;
      			OCR3BL=speed;
			};

			current_timer++;
		  }else{
		    OCR3BH=0x00;
      		OCR3BL=0x00;
			OCR3AH=0x00;
      		OCR3AL=0x00;
		  };

		};

	 }else{


		 //***************************************************************************************************
         //Here is ADC-reading block
         //***************************************************************************************************
	     
		 //Do ADC scan in 1681-2149 cycles
		 
		 //Find first ADC need reading
	     if(tmr==1681){
		 	adc_id=0;
			while( types[adc_id]!=3 && adc_id<8) adc_id++;
			adc_conv=0;
		 };
	 
	     //Read all ADC values consequently
		 if(adc_id<8){
		    if(adc_conv==0){
		   		outb(ADMUX, (inb(ADMUX) & ~0x1F) | (adc_id & 0x1F));	// set channel
				sbi(ADCSRA, ADIF);						// clear hardware "conversion complete" flag 
				sbi(ADCSRA, ADSC);						// start conversion
				adc_conv=1;
			}else{
				if( bit_is_set(ADCSRA, ADSC) ){		// wait until conversion complete
					adc_conv=0;
					if(types[adc_id]==3) value[adc_id]=inb(ADCH);
					while( types[adc_id]!=3 && adc_id<8) adc_id++;
				};
			};

		 };

	 };
	 

  };

  tmr++;
  if(tmr==2150){
    tmr=0;
  };

};

static void ioinit(void)
{
  uart_init();
  i2cInit();
};

static void dec2hex(int x, char *c1, char *c2){
  char cc1=(x & 0xf0)>>4;
  char cc2=(x & 0x0f);
  *c1=cc1>9?cc1+'A'-10:cc1+'0';
  *c2=cc2>9?cc2+'A'-10:cc2+'0';
};

static int hex2dec(char a, char b, uint8_t* res){
  if(a<'0' || a>'F' || (a>'9' && a<'A')){
	return 0;
  };
  if(b<'0' || b>'F' || (b>'9' && b<'A')){
	return 0;
  };
  *res=(a>'9'?a-'A'+10:a-'0')*16 + (b>'9'?b-'A'+10:b-'0');

  #ifdef DEBUG
  printf("hex2dec(%c%c)=%d\n",a,b,*res);
  #endif

  return 1;
};

//static void requestI2Cbus(int adr, char* request, int req_len, char* answer, int ans_len){
//  i2cMasterTransferNI(adr << 1, req_len, request, ans_len, answer);
//};

static int requestI2Cbus2(int adr, char* request, int req_len, char* answer, int ans_len){
  return i2cMasterTransferNI2(adr << 1, req_len, request, ans_len, answer, 1000);
};

static void update_t(int i){
  uint8_t snd;

  #ifdef DEBUG
  printf("Ut[%d,%d,%d]\n",i,types[i],prt[i]);
  #endif

  if( prt[i]==0 ){ snd=inb(DDRA); };
  if( prt[i]==1 ){ snd=inb(DDRB); };
  if( prt[i]==2 ){ snd=inb(DDRC); };
  if( prt[i]==3 ){ snd=inb(DDRD); };
  if( prt[i]==4 ){ snd=inb(DDRE); };
  if( prt[i]==5 ){ snd=inb(DDRF); };
  if( prt[i]==6 ){ snd=inb(DDRG); };
  if(types[i]==0){ snd=snd & (0xff-pin[i]); }; //TTL input pin
  if(types[i]==3){ snd=snd & (0xff-pin[i]); }; //TTL input pin
  if(types[i]==1 || types[i]==2){ snd=snd | pin[i]; }; //TTL output pin 
  if( prt[i]==0 ){ outb(DDRA,snd); };
  if( prt[i]==1 ){ outb(DDRB,snd); };
  if( prt[i]==2 ){ outb(DDRC,snd); };
  if( prt[i]==3 ){ outb(DDRD,snd); };
  if( prt[i]==4 ){ outb(DDRE,snd); };
  if( prt[i]==5 ){ outb(DDRF,snd); };
  if( prt[i]==6 ){ outb(DDRG,snd); };
};

static void update_r(int i){
  if( types[i]==0) //TTL input pin
  {

	  uint8_t snd;
	  if( prt[i]==0 ){ snd=inb(PINA); };
	  if( prt[i]==1 ){ snd=inb(PINB); };
	  if( prt[i]==2 ){ snd=inb(PINC); };
	  if( prt[i]==3 ){ snd=inb(PIND); };
	  if( prt[i]==4 ){ snd=inb(PINE); };
	  if( prt[i]==5 ){ snd=inb(PINF); };
	  if( prt[i]==6 ){ snd=inb(PING); };

	  #ifdef DEBUG
	  printf("Ur[%d,%d,%d,%d]=%d\n",i,types[i],prt[i],value[i],snd);
	  #endif

	  value[i]=(snd & pin[i])?1:0;
	  return;
  };
};

static void update_w(int i){

  uint8_t snd;

  #ifdef DEBUG
  printf("Uw[%d,%d,%d,%d]\n",i,types[i],prt[i],value[i]);
  #endif

  //Motor direction and speed values
  if( i>= 0x10 ){
    if( i==0x10 ){
	  if( value[i]==01 ){
		outb(PORTD,inb(PORTD) & 0xEF); //Set PD4=0
		return;
      };
	  if( value[i]==02 ){
		outb(PORTD,inb(PORTD) | 0x10); //Set PD4=1
		return;
      };
	  return;
	};
	if( i==0x11 ){
	  OCR3BH=0x00;
      OCR3BL=value[i];
	};
    if( i==0x12 ){
	  if( value[i]==01 ){
		outb(PORTD,inb(PORTD) & 0xDF); //Set PB5=0
		return;
      };
	  if( value[i]==02 ){
	    outb(PORTD,inb(PORTD) | 0x20); //Set PB5=1
		return;
      };
	  return;
	};
	if( i==0x13 ){
	  OCR3AH=0x00;
      OCR3AL=value[i];
	};
	return;
  };

  //Standart 0x00-0x0F port values

  if( prt[i]==0 ){ snd=inb(PORTA); };
  if( prt[i]==1 ){ snd=inb(PORTB); };
  if( prt[i]==2 ){ snd=inb(PORTC); };
  if( prt[i]==3 ){ snd=inb(PORTD); };
  if( prt[i]==4 ){ snd=inb(PORTE); };
  if( prt[i]==5 ){ snd=inb(PORTF); };
  if( prt[i]==6 ){ snd=inb(PORTG); };

  if( (types[i]==0 || types[i]==1) ) //TTL i/o pin
  {
     if(value[i]==0){
	   snd=snd & (0xff - pin[i]);
	 }else{
	   snd=snd | pin[i];
	 };
  };

  if( prt[i]==0 ){ outb(PORTA,snd); };
  if( prt[i]==1 ){ outb(PORTB,snd); };
  if( prt[i]==2 ){ outb(PORTC,snd); };
  if( prt[i]==3 ){ outb(PORTD,snd); };
  if( prt[i]==4 ){ outb(PORTE,snd); };
  if( prt[i]==5 ){ outb(PORTF,snd); };
  if( prt[i]==6 ){ outb(PORTG,snd); };
};

static int processI2Crequest(int adr, char* request, int req_len, char* answer){
  
  if(adr!=255){ return 0; };
  if(req_len==1){
    if(request[0]==255){
	  //Version info
      answer[0]=0x00;
      answer[1]=0x00;
	  answer[2]=0x00;
	  answer[3]=0x01;
	  return 1;
    };
  };

  if(request[0]==0x14){
    if(req_len==1){
	  queue_size=0;
	  return 1;
	}else{
	  if( queue_size==0 ){
	    current_timer=0;
		if(startLeft==0 && startRight==0){
			startLeft=cnt_left;
			startRight=cnt_right;
		};
	  };
	  int r6=0;
	  while(r6+4<req_len){
	    speed1s[queue_size]=request[2+r6];
	    speed2s[queue_size]=request[3+r6];
	    speed1f[queue_size]=request[4+r6];
	    speed2f[queue_size]=request[5+r6];
	    time[queue_size]=request[1+r6];
	    queue_size++;
		r6+=5;
	  };
	  return 1;
	};
  };
  
  if(req_len==2){
    if(request[0]<0x14){

	  #ifdef DEBUG
	  printf("Set value[%d]=%d\n",request[0],request[1]);
	  #endif
	  
	  value[request[0]]=request[1];
	  update_w(request[0]);
	  return 1;
	};
	if(request[0]>=0x20 && request[0]<0x30){

	  #ifdef DEBUG
	  printf("Set types[%d]=%d\n",request[0]-0x20,request[1]);
	  #endif

  	  types[request[0]-0x20]=request[1];
	  update_t(request[0]-0x20);
	  return 1;
	};
  };
  if(req_len==1){
    if(request[0]>=0x80 && request[0]<0x90){
	  update_r(request[0]-0x80);
  	  answer[0]=value[request[0]-0x80];
	  
	  #ifdef DEBUG
	  printf("Get values[%d]=%d\n",request[0]-0x80,answer[0]);
	  #endif

	  return 1;
	};
	if(request[0]>=0xA0 && request[0]<0xB0){
  	  answer[0]=types[request[0]-0xA0];

	  #ifdef DEBUG
	  printf("Get types[%d]=%d\n",request[0]-0xA0,answer[0]);
	  #endif

	  return 1;
	};
  };
  return 1;
};

static int process(char* buf, uint8_t len){
  //Getting i2c request from RS-232 request
  if(len<5){
    printf("X01Command\n");
	return 0;
  };
  if(buf[0]!='Q'){
    printf("X02Command\n");
	return 0;
  };
  uint8_t adr;
  if( !hex2dec(buf[1],buf[2],&adr) ){
    printf("X03Address\n");
	return 0;
  };
  uint8_t readBytes=0;
  if( !hex2dec(buf[3],buf[4],&readBytes) ){
    printf("X04NumBytesToRead\n");
	return 0;
  };
  if( readBytes>64 ){
    printf("X05NumBytesToRead\n");
    return 0;
  };
  int current=5;
  if( ((len-current) & 0x01) == 1){
    printf("X06BytesToSend\n");
	return 0;
  };
  uint8_t bytebuf1[64];
  uint8_t bytebuf2[64];
  int sendBytes=0;
  while(current<len){
    if( !hex2dec(buf[current],buf[current+1],&(bytebuf1[sendBytes])) ){
      printf("X07BytesToSend\n");
	  return 0;
    };
	current+=2;
	sendBytes++;
	if( sendBytes>64 ){
      printf("X08NumBytesToSend\n");
	  return 0;
    };
  };

  //Processing i2c request
  #ifdef DEBUG2
  printf("Address: %d\n",adr);
  printf("Bytes To Write: %d\n",sendBytes);
  printf("Bytes To Read: %d\n",readBytes);
  #endif

  //Test bytesbuf[] clearing
  int j=0;
  while(j<readBytes){
    bytebuf2[j]=0;
    j++;
  };
  
  int res;
  if(adr>127){
    res=processI2Crequest(adr,bytebuf1,sendBytes,bytebuf2);
  }else{
    res=requestI2Cbus2(adr,bytebuf1,sendBytes,bytebuf2,readBytes);
  };
  
  if(res==0){
    printf("X00Timeout!\n");
	return 0;
  };

  //Forming answer from i2c answer for RS-232
  printf("R");
  current=3;
  int i=0;
  while(i<readBytes){
    char c1,c2;
    dec2hex(bytebuf2[i],&c1,&c2);
    printf("%c%c",c1,c2);
	i++;
  };
  printf("\n");
  return 1;
  
};

FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

char getch(void)
{
  loop_until_bit_is_set(UCSR0A, RXC);
  if (UCSR0A & _BV(FE))
    return _FDEV_EOF;
  if (UCSR0A & _BV(DOR))
    return _FDEV_ERR;
  char c = UDR0;
  return c;
};

int main(void)
{

  char buf[200];

  ioinit();

  outb(DDRE,inb(DDRE) | 0x18);
  outb(PORTE,inb(PORTE) & ~0x18);

  stdout = stdin = &uart_str;

  pin[0]=0; prt[0]=5;
  pin[1]=1; prt[1]=5;
  pin[2]=2; prt[2]=5;
  pin[3]=3; prt[3]=5;
  pin[4]=4; prt[4]=5;
  pin[5]=5; prt[5]=5;
  pin[6]=6; prt[6]=5;
  pin[7]=7; prt[7]=5;
  pin[8]=0; prt[8]=6;
  pin[9]=1; prt[9]=6;
  pin[10]=2; prt[10]=6;
  pin[11]=3; prt[11]=6;
  pin[12]=4; prt[12]=6;
  pin[13]=0; prt[13]=1;
  pin[14]=2; prt[14]=1;
  pin[15]=7; prt[15]=1;

  int i;
  for(i=0; i<16; i++){
    pin[i]=1 << pin[i];
    types[i]=0;
	update_t(i);
	value[i]=0;
	update_w(i);
  };

  for(i=16; i<20; i++){
    pin[i]=1 << pin[i];
	value[i]=0;
	update_w(i);
    types[i]=1;
	update_t(i);
  };

  sbi(ADCSRA, ADEN);									// enable ADC (turn on ADC power)
  cbi(ADCSRA, ADFR);									// disable "free running" mode
  outb(ADCSRA, ((inb(ADCSRA) & ~0x07) | 0x06));		// set default prescaler CPU clk/64
  outb(ADMUX, ((inb(ADMUX) & ~0xC0) | (0x01<<6)));	// set default reference VCC pin
  sbi(ADMUX, ADLAR);								// set to left-adjusted result
  
  // Initiating Timer/Counter-1 Control Registers:
  //  
  // TCCR1A = COM1A1:COM1A0:COM1B1:COM1B0:FOC1A:FOC1B:WGM11:WGM10
  //             1      0      1      0     0     0     0     1
  //
  // TCCR1B = ICNC1:ICES1:-:WGM13:WGM12:CS12:CS11:CS10
  //            0     0   0   0     1     0    1    0
  //
  // COM1x1:COM1x0 = 1:0 => OC1x connected to output pin, reset on compare
  // FOC1A:FOC1B = 0:0 => Don't force output compare event
  // WGM13:WGM12:WGM11:WGM10 = 0:1:0:1 => Fast PWM 8-bit
  // ICNC1 = 0 => Input Capture Noise Canceller disabled (because not needed)
  // ICES1 = 0 => Input Capture Edge Select set to "falling" mode (no matter)
  // CS12:CS11:CS10 = 0:1:0 => Timer "on", 1/8 prescaling (1 clock every 8 cpu tact)
  TCCR3A=0xA1;
  TCCR3B=0x0A;

  TCNT3H=0x00;
  TCNT3L=0x00;
 
  // Initiating Timer/Counter-0 Control Registers:
  //  
  // TCCR0 = FOC0:WGM00:COM01:COM00:WGM01:CS02:CS01:CS00
  //          0     0     0     0     0     0    0    1
  //
  // COM1x1:COM1x0 = 0:0 => OC1x disconnected from output pin
  // FOC1A:FOC1B = 0:0 => Don't force output compare event
  // WGM13:WGM12:WGM11:WGM10 = 0:0:0:0 => Normal timer/counter operation
  // ICNC1 = 0 => Input Capture Noise Canceller disabled (because not needed)
  // ICES1 = 0 => Input Capture Edge Select set to "falling" mode (no matter)
  // CS12:CS11:CS10 = 0:0:1 => Timer "on", no prescaling (1 clock every cpu tact)
  // TCCR1A = 00000000 = 0x00
  TCCR2=0x01;

  TCNT2=0x69;

  // Initiating internal program subcounter with zero
  tmr=0;

  //Last position

  // Initiating Timer/Counter Interrupt Mask register:
  //
  // TIMSK = OCIE2:TOIE2:TICIE1:OCIE1A:OCIE1B:TOIE1:OCIE0:TOIE0
  //           0     1      0      0      0     0     0     0
  //
  // OCIE2 = 0 => Timer/Counter2 Output Compare Match Interrupt disabled
  // TOIE2 = 1 => Timer/Counter2 Timer Overflow disabled
  // TICIE1 = 0 => Timer/Counter1 Input Capture Interrupt disabled
  // OCIE1x = 0 => Timer/Counter1 Output Compare Match Interrupt disabled
  // TOIE1 = 0 => Timer/Counter1 Timer Overflow enabled
  // OCIE0 = 0 => Timer/Counter0 Output Compare Match Interrupt disabled
  // TOIE0 = 0 => Timer/Counter0 Timer Overflow disabled
  
  TIMSK=0x40;

  // Initiating Output Compare Registers for unknown reason (?)
  OCR3AH=0x00;
  OCR3AL=0x00;
  OCR3BH=0x00;
  OCR3BL=0x00;
  
  EICRA=0x00;
  EICRB=0xF0;
  EIMSK=0xC0;
  EIFR=0xC0;
  
  queue_size=0;

  //Initialize bluetooth module
  outb(DDRE,inb(DDRE) | 0x04);
  outb(PORTE,inb(PORTE) | 0x04);
  int j; for (j=0;j<0xFF;j++);
  outb(PORTE,inb(PORTE) & ~0x04);

  printf("Ready!\n");

  cnt_left=0;
  cnt_right=0;
  
  startLeft=0;
  startRight=0;

  sei();

  while(1){
    int l=0;
	char c=getch();
	while(c!='Q') c=getch();
	while(c!='P'){ buf[l++]=c; c=getch(); };

	//printf("l=%d\n",l);

	process(buf,l);
  };
 
  return 0;
  
}
